/*
 * GXMame
 *
 * 2002, 2003, Stphane Pontier <shadow_walker@users.sourceforge.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "gxmame.h"
#include "gui.h"
#include "audit.h"
#include "interface.h"
#include "support.h"
#include "options.h"

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/wait.h>

#define BUFFER_SIZE 1000

GtkWidget *roms_check_progressbar;
GtkWidget *samples_check_progressbar;
GtkWidget *checking_games_window;
GtkWidget *details_check_text;
GtkWidget *correct_roms_value;
GtkWidget *bestavailable_roms_value;
GtkWidget *notfound_roms_value;
GtkWidget *incorrect_roms_value;
GtkWidget *total_roms_value;
GtkWidget *correct_samples_value;
GtkWidget *incorrect_samples_value;
GtkWidget *total_samples_value;
GtkWidget *done_audit_button;


GtkWidget*
create_checking_games_window (void)
{
	GtkWidget *table3;
/*
	GtkWidget *pause_audit_button;
	GtkWidget *cancel_audit_button;
*/
	GtkWidget *details_frame;
	GtkWidget *scrolledwindow6;
	GtkWidget *ROMs_frame;
	GtkWidget *table4;
	GtkWidget *total_roms_label;
	GtkWidget *incorrect_roms_label;
	GtkWidget *correct_roms_label;
	GtkWidget *bestavailable_roms_label;
	GtkWidget *notfound_roms_label;
	GtkWidget *samples_frame;
	GtkWidget *table5;
	GtkWidget *incorrect_samples_label;
	GtkWidget *total_samples_label;
	GtkWidget *correct_samples_label;

	checking_games_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (checking_games_window), "checking_games_window", checking_games_window);
	gtk_container_set_border_width (GTK_CONTAINER (checking_games_window), 5);
	gtk_window_set_title (GTK_WINDOW (checking_games_window), _("Checking Game"));
	gtk_window_set_transient_for(GTK_WINDOW(checking_games_window),GTK_WINDOW(MainWindow));
	gtk_window_set_modal(GTK_WINDOW(checking_games_window),TRUE);

	table3 = gtk_table_new (3, 4, FALSE);
	gtk_widget_ref (table3);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "table3", table3,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (table3);
	gtk_container_add (GTK_CONTAINER (checking_games_window), table3);
	gtk_table_set_row_spacings (GTK_TABLE (table3), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table3), 5);

/*
	pause_audit_button = gtk_button_new_with_label (_("Pause"));
	gtk_widget_ref (pause_audit_button);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "pause_audit_button", pause_audit_button,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (pause_audit_button);
	gtk_table_attach (GTK_TABLE (table3), pause_audit_button, 1, 2, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);

	cancel_audit_button = gtk_button_new_with_label (_("Cancel"));
	gtk_widget_ref (cancel_audit_button);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "cancel_audit_button", cancel_audit_button,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (cancel_audit_button);
	gtk_table_attach (GTK_TABLE (table3), cancel_audit_button, 2, 3, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
*/
	
	done_audit_button = gtk_button_new_with_label (_("Done"));
	gtk_widget_ref (done_audit_button);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "done_audit_button", done_audit_button,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (done_audit_button);
	gtk_table_attach (GTK_TABLE (table3), done_audit_button, 3, 4, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	/* only allows to clic it when the audit is done */
	gtk_widget_set_sensitive(done_audit_button,FALSE);

	details_frame = gtk_frame_new (_("Details"));
	gtk_widget_ref (details_frame);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "details_frame", details_frame,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (details_frame);
	gtk_table_attach (GTK_TABLE (table3), details_frame, 0, 4, 1, 2,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

	scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_ref (scrolledwindow6);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "scrolledwindow6", scrolledwindow6,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (scrolledwindow6);
	gtk_container_add (GTK_CONTAINER (details_frame), scrolledwindow6);
	gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow6), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	details_check_text = gtk_text_new (NULL, NULL);
	gtk_widget_ref (details_check_text);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "details_check_text", details_check_text,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (details_check_text);
	gtk_container_add (GTK_CONTAINER (scrolledwindow6), details_check_text);

	ROMs_frame = gtk_frame_new (_("ROMs"));
	gtk_widget_ref (ROMs_frame);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "ROMs_frame", ROMs_frame,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (ROMs_frame);
	gtk_table_attach (GTK_TABLE (table3), ROMs_frame, 0, 2, 0, 1,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 0);

	table4 = gtk_table_new (4, 3, FALSE);
	gtk_widget_ref (table4);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "table4", table4,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (table4);
	gtk_container_add (GTK_CONTAINER (ROMs_frame), table4);
	gtk_container_set_border_width (GTK_CONTAINER (table4), 5);
	gtk_table_set_row_spacings (GTK_TABLE (table4), 2);

	correct_roms_value = gtk_label_new ("0");
	gtk_widget_ref (correct_roms_value);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "correct_roms_value", correct_roms_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (correct_roms_value);
	gtk_table_attach (GTK_TABLE (table4), correct_roms_value, 2, 3, 1, 2,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (correct_roms_value), 0, 0.5);

	bestavailable_roms_value = gtk_label_new ("0");
	gtk_widget_ref (bestavailable_roms_value);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "bestavailable_roms_value", bestavailable_roms_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (bestavailable_roms_value);
	gtk_table_attach (GTK_TABLE (table4), bestavailable_roms_value, 2, 3, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (bestavailable_roms_value), 0, 0.5);

	incorrect_roms_value = gtk_label_new ("0");
	gtk_widget_ref (incorrect_roms_value);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "incorrect_roms_value", incorrect_roms_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (incorrect_roms_value);
	gtk_table_attach (GTK_TABLE (table4), incorrect_roms_value, 2, 3, 3, 4,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (incorrect_roms_value), 0, 0.5);

	notfound_roms_value = gtk_label_new ("0");
	gtk_widget_ref (notfound_roms_value);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "notfound_roms_value", notfound_roms_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (notfound_roms_value);
	gtk_table_attach (GTK_TABLE (table4), notfound_roms_value, 2, 3, 4, 5,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (notfound_roms_value), 0, 0.5);

	total_roms_value = gtk_label_new ("0");
	gtk_widget_ref (total_roms_value);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "total_roms_value", total_roms_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (total_roms_value);
	gtk_table_attach (GTK_TABLE (table4), total_roms_value, 2, 3, 5, 6,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (total_roms_value), 0, 0.5);

	total_roms_label = gtk_label_new (_("Total:"));
	gtk_widget_ref (total_roms_label);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "total_roms_label", total_roms_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (total_roms_label);
	gtk_table_attach (GTK_TABLE (table4), total_roms_label, 1, 2, 5, 6,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (total_roms_label), 0, 0.5);

	notfound_roms_label = gtk_label_new (_("Not found:"));
	gtk_widget_ref (notfound_roms_label);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "notfound_roms_label", notfound_roms_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (notfound_roms_label);
	gtk_table_attach (GTK_TABLE (table4), notfound_roms_label, 1, 2, 4, 5,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (notfound_roms_label), 0, 0.5);

	incorrect_roms_label = gtk_label_new (_("Incorrect:"));
	gtk_widget_ref (incorrect_roms_label);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "incorrect_roms_label", incorrect_roms_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (incorrect_roms_label);
	gtk_table_attach (GTK_TABLE (table4), incorrect_roms_label, 1, 2, 3, 4,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (incorrect_roms_label), 0, 0.5);

	bestavailable_roms_label = gtk_label_new (_("Best available:"));
	gtk_widget_ref (bestavailable_roms_label);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "bestavailable_roms_label", bestavailable_roms_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (bestavailable_roms_label);
	gtk_table_attach (GTK_TABLE (table4), bestavailable_roms_label, 1, 2, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (bestavailable_roms_label), 0, 0.5);

	correct_roms_label = gtk_label_new (_("Correct:"));
	gtk_widget_ref (correct_roms_label);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "correct_roms_label", correct_roms_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (correct_roms_label);
	gtk_table_attach (GTK_TABLE (table4), correct_roms_label, 1, 2, 1, 2,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (correct_roms_label), 0, 0.5);

	roms_check_progressbar = gtk_progress_bar_new ();
	gtk_widget_ref (roms_check_progressbar);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "roms_check_progressbar", roms_check_progressbar,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (roms_check_progressbar);
	gtk_table_attach (GTK_TABLE (table4), roms_check_progressbar, 0, 3, 0, 1,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (roms_check_progressbar, -2, 13);

	samples_frame = gtk_frame_new (_("Samples"));
	gtk_widget_ref (samples_frame);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "samples_frame", samples_frame,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (samples_frame);
	gtk_table_attach (GTK_TABLE (table3), samples_frame, 2, 4, 0, 1,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (GTK_FILL), 0, 0);

	table5 = gtk_table_new (4, 3, FALSE);
	gtk_widget_ref (table5);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "table5", table5,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (table5);
	gtk_container_add (GTK_CONTAINER (samples_frame), table5);
	gtk_container_set_border_width (GTK_CONTAINER (table5), 5);
	gtk_table_set_row_spacings (GTK_TABLE (table5), 2);

	correct_samples_value = gtk_label_new ("0");
	gtk_widget_ref (correct_samples_value);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "correct_samples_value", correct_samples_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (correct_samples_value);
	gtk_table_attach (GTK_TABLE (table5), correct_samples_value, 2, 3, 1, 2,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (correct_samples_value), 0, 0.5);

	incorrect_samples_value = gtk_label_new ("0");
	gtk_widget_ref (incorrect_samples_value);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "incorrect_samples_value", incorrect_samples_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (incorrect_samples_value);
	gtk_table_attach (GTK_TABLE (table5), incorrect_samples_value, 2, 3, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (incorrect_samples_value), 0, 0.5);

	incorrect_samples_label = gtk_label_new (_("Incorrect:"));
	gtk_widget_ref (incorrect_samples_label);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "incorrect_samples_label", incorrect_samples_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (incorrect_samples_label);
	gtk_table_attach (GTK_TABLE (table5), incorrect_samples_label, 1, 2, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (incorrect_samples_label), 0, 0.5);

	total_samples_label = gtk_label_new (_("Total:"));
	gtk_widget_ref (total_samples_label);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "total_samples_label", total_samples_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (total_samples_label);
	gtk_table_attach (GTK_TABLE (table5), total_samples_label, 1, 2, 3, 4,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (total_samples_label), 0, 0.5);

	total_samples_value = gtk_label_new ("0");
	gtk_widget_ref (total_samples_value);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "total_samples_value", total_samples_value,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (total_samples_value);
	gtk_table_attach (GTK_TABLE (table5), total_samples_value, 2, 3, 3, 4,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (total_samples_value), 0, 0.5);

	correct_samples_label = gtk_label_new (_("Correct:"));
	gtk_widget_ref (correct_samples_label);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "correct_samples_label", correct_samples_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (correct_samples_label);
	gtk_table_attach (GTK_TABLE (table5), correct_samples_label, 1, 2, 1, 2,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (correct_samples_label), 0, 0.5);

	samples_check_progressbar = gtk_progress_bar_new ();
	gtk_widget_ref (samples_check_progressbar);
	gtk_object_set_data_full (GTK_OBJECT (checking_games_window), "samples_check_progressbar", samples_check_progressbar,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (samples_check_progressbar);
	gtk_table_attach (GTK_TABLE (table5), samples_check_progressbar, 0, 3, 0, 1,
			  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (samples_check_progressbar, -2, 13);
	gtk_widget_show(checking_games_window);
	set_icon(checking_games_window,_("Audit"));
	return checking_games_window;
}


/* this audit works but is ininterruptible and moreover due to the pipe buffer size,
   freeze the qui a moment before displaying results*/
void launch_checking_games_window_1(void)
{
	FILE *xmame_pipe=NULL;
	gchar line[BUFFER_SIZE];
	gchar title[BUFFER_SIZE];
	gchar numb[10];
	gfloat done;
	guint nb_checked = 1,nb_good = 0,nb_incorrect = 0,nb_bestavailable = 0,nb_notfound = 0;
	gboolean error_during_check=FALSE,game_found;
	gchar *command, *p, *name;
	gchar *rompath_option,*samplepath_option;
	GList *listpointer;
	RomEntry *tmprom = NULL;
	guint status;
	GTimer *mytimer;
	
			
	rompath_option = create_RomPath_Related_options_string();
	command = g_strdup_printf("%s -verifyroms %s 2>/dev/null",
			real_mame_executable,
			rompath_option);
	g_free(rompath_option);
	gxmame_debug("running command %s",command);
	mytimer=g_timer_new();
	g_timer_start(mytimer);
	xmame_pipe = popen(command, "r");
	/* Loading */
	fflush(xmame_pipe);
	while (fgets(line, BUFFER_SIZE, xmame_pipe))
	{
		/* jump the last comments */
		if (strlen(line)<=1)
			break;
		/* remove the last \n */
		line[strlen(line) - 1] = 0;
		if (!strncmp(line,"romset",6))
		{
			for(p = name = line+7;(*p && (*p != ' '));p++);
			*p='\0';p++;
			done = (gfloat) ((gfloat) (nb_checked) /
					(gfloat) (supported_games));
/*			printf("%i - %i\n",nb_checked,supported_games);*/
			if (!strncmp(p,"correct",7))
			{
				nb_good++;
/*				printf("name: %s, resultat:%s(good), done:%0.3f\n",name,p,done);*/
				g_snprintf(numb,10,"%d",nb_good);
				gtk_label_set_text(GTK_LABEL(correct_roms_value),numb);
				g_snprintf(numb,10,"%d",nb_good+nb_incorrect+nb_notfound+nb_bestavailable);
				gtk_label_set_text(GTK_LABEL(total_roms_value),numb);
				status = 1;
			}
			else if (!strncmp(p,"incorrect",9) && error_during_check==TRUE)
			{
				nb_incorrect++;
				g_snprintf(numb,10,"%d",nb_incorrect);
				gtk_label_set_text(GTK_LABEL(incorrect_roms_value),numb);
				g_snprintf(numb,10,"%d",nb_good+nb_incorrect+nb_notfound+nb_bestavailable);
				gtk_label_set_text(GTK_LABEL(total_roms_value),numb);
				sprintf(title,"%s: Incorrect\n",line);
				gtk_text_insert (GTK_TEXT (details_check_text), NULL, NULL, NULL,title, -1);
				status = 0;
			} 
			else if (!strncmp(p,"not found",9))
			{
				nb_notfound++;
				g_snprintf(numb,10,"%d",nb_notfound);
				gtk_label_set_text(GTK_LABEL(notfound_roms_value),numb);
				g_snprintf(numb,10,"%d",nb_good+nb_incorrect+nb_notfound+nb_bestavailable);
				gtk_label_set_text(GTK_LABEL(total_roms_value),numb);
				sprintf(title,"%s: Not found\n",line);
				gtk_text_insert (GTK_TEXT (details_check_text), NULL, NULL, NULL,title, -1);
				status = 0;
			}
			else if (!strncmp(p,"best available",14))
			{
				nb_bestavailable++;
				g_snprintf(numb,10,"%d",nb_bestavailable);
				gtk_label_set_text(GTK_LABEL(bestavailable_roms_value),numb);
				g_snprintf(numb,10,"%d",nb_good+nb_incorrect+nb_notfound+nb_bestavailable);
				gtk_label_set_text(GTK_LABEL(total_roms_value),numb);
				status = 1;
			}
			else 
			{
				printf("????\n");
				status = 2;
			}	
				
			/* find the rom in the list */
			for(listpointer = g_list_first(roms), game_found = FALSE;
					(listpointer != NULL);
					listpointer = g_list_next(listpointer))
			{
				tmprom = (RomEntry *) listpointer->data;
				if (!strcmp(tmprom->romname,name))
				{
					game_found = TRUE;
					break;
				}
			}
			if (game_found)
			{
				tmprom->has_roms = status;
				g_snprintf(title,BUFFER_SIZE,_("Checking Game %s %s %s"),name, tmprom->gamename,tmprom->gamenameext );
				if (tmprom->the_trailer && gui_prefs.ModifyThe)
					g_snprintf(title,BUFFER_SIZE,"Checking Game %s, The %s",tmprom->gamename,tmprom->gamenameext);
				else if (tmprom->the_trailer && !gui_prefs.ModifyThe)
					g_snprintf(title,BUFFER_SIZE,"Checking Game The %s %s",tmprom->gamename,tmprom->gamenameext);
				else
					g_snprintf(title,BUFFER_SIZE,"Checking Game %s %s",tmprom->gamename,tmprom->gamenameext);
			}
			else
			{/* haven't found the game, just diplay the gamename */
				g_snprintf(title,BUFFER_SIZE,_("Checking Game %s"),name);
			}
			/*continue with the GUI */
			nb_checked++;
			error_during_check = FALSE;
			gtk_window_set_title (GTK_WINDOW (checking_games_window), title);
			gtk_progress_bar_update(GTK_PROGRESS_BAR(roms_check_progressbar),done);
			while (gtk_events_pending()) gtk_main_iteration();
		}
		else
		{
			g_snprintf(title,BUFFER_SIZE,"%s\n",line);
			
			gtk_text_insert (GTK_TEXT (details_check_text), NULL, NULL, NULL,title, -1);
			error_during_check = TRUE;
			while (gtk_events_pending()) gtk_main_iteration();
		}
		fflush(xmame_pipe);
		while (gtk_events_pending()) gtk_main_iteration();
		fflush(xmame_pipe);
	}
	pclose(xmame_pipe);
	g_free(command);
	g_timer_stop(mytimer);
	g_message(_("time elapsed:%e"),g_timer_elapsed(mytimer,NULL));
	
	/*Samples now*/
	nb_good = nb_incorrect = 0;
	nb_checked = 1;
			
	samplepath_option = create_SamplePath_Related_options_string();
	command = g_strdup_printf("%s -verifysamples %s 2>/dev/null",
			real_mame_executable,
			samplepath_option);
	g_free(samplepath_option);
	gxmame_debug("running command %s",command);
	xmame_pipe = popen(command, "r");
	/* Loading */
	while (fgets(line, BUFFER_SIZE, xmame_pipe))
	{
		/* jump the last comments */
		if (strlen(line)<=1)
			break;
		/* remove the last \n */
		line[strlen(line) - 1] = 0;
		if (!strncmp(line,"sampleset",9))
		{
			for(p = name = line+10;(*p && (*p != ' '));p++);
			*p='\0';p++;
/*			printf("done= %f = (%d / %d)\n",done,nb_checked,supported_samples_games);*/
			done = (gfloat) ((gfloat) (nb_checked) /
					(gfloat) (supported_samples_games));
			if (!strncmp(p,"correct",7))
			{
				nb_good++;
/*				printf("name: %s, resultat:%s(good), done:%0.3f\n",name,p,done);*/
				g_snprintf(numb,10,"%d",nb_good);
				gtk_label_set_text(GTK_LABEL(correct_samples_value),numb);
				g_snprintf(numb,10,"%d",nb_good+nb_incorrect);
				gtk_label_set_text(GTK_LABEL(total_samples_value),numb);
				status = 1;
			}
			else if (!strncmp(p,"incorrect",9) && error_during_check==TRUE)
			{
				nb_incorrect++;
/*				printf("	name: %s, resultat:%s(\?\?\?), done:%0.3f\n",name,p,done);*/
				g_snprintf(numb,10,"%d",nb_incorrect);
				gtk_label_set_text(GTK_LABEL(incorrect_samples_value),numb);
				g_snprintf(numb,10,"%d",nb_good+nb_incorrect);
				gtk_label_set_text(GTK_LABEL(total_samples_value),numb);
				status = 0;
			} else
				status = 2;
			/* find the rom in the list */
			for(listpointer = g_list_first(roms), game_found = FALSE;
					(listpointer != NULL);
					listpointer = g_list_next(listpointer))
			{
				tmprom = (RomEntry *) listpointer->data;
				if (!strcmp(tmprom->romname,name))
				{
					game_found = TRUE;
					break;
				}
			}
			if (game_found)
			{
				tmprom->has_samples = status;
				g_snprintf(title,BUFFER_SIZE,_("Checking Game %s %s %s"),name, tmprom->gamename,tmprom->gamenameext );
				if (tmprom->the_trailer && gui_prefs.ModifyThe)
					g_snprintf(title,BUFFER_SIZE,"Checking Game %s, The %s",tmprom->gamename,tmprom->gamenameext);
				else if (tmprom->the_trailer && !gui_prefs.ModifyThe)
					g_snprintf(title,BUFFER_SIZE,"Checking Game The %s %s",tmprom->gamename,tmprom->gamenameext);
				else
					g_snprintf(title,BUFFER_SIZE,"Checking Game %s %s",tmprom->gamename,tmprom->gamenameext);
			}
			/*continue with the GUI */
			nb_checked++;
			error_during_check = FALSE;
			g_snprintf(title,BUFFER_SIZE,_("Checking Game %s"),name);
			gtk_window_set_title (GTK_WINDOW (checking_games_window), title);
			gtk_progress_bar_update(GTK_PROGRESS_BAR(samples_check_progressbar),done);
			while (gtk_events_pending()) gtk_main_iteration();
		}
		else
		{
			g_snprintf(title,BUFFER_SIZE,"%s\n",line);
			
			gtk_text_insert (GTK_TEXT (details_check_text), NULL, NULL, NULL,title, -1);
			error_during_check = TRUE;
			while (gtk_events_pending()) gtk_main_iteration();
		}
		fflush(xmame_pipe);
		while (gtk_events_pending()) gtk_main_iteration();
		fflush(xmame_pipe);
	}
	pclose(xmame_pipe);
	g_free(command);
	gtk_window_set_title (GTK_WINDOW (checking_games_window), _("Audit done"));
	gtk_text_insert (GTK_TEXT (details_check_text), NULL, NULL, NULL,_("Audit done"), -1);
	create_gamelist_content();
	gtk_widget_set_sensitive(done_audit_button,TRUE);
	gtk_signal_connect_object (GTK_OBJECT (done_audit_button), "clicked",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy),
			    GTK_OBJECT (checking_games_window));
	gtk_signal_connect (GTK_OBJECT (checking_games_window), "delete_event",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy),
			    NULL);
	
}



void launch_checking_games_window_2(void)
{
	gchar line[BUFFER_SIZE];
	gchar title[BUFFER_SIZE];
	gchar numb[10];
	gfloat done;
	guint nb_checked = 1,nb_good = 0,nb_incorrect = 0;
	gboolean error_during_check=FALSE,game_found;
	gchar *command, *p, *name;
	GList *listpointer;
	RomEntry *tmprom = NULL;
	guint status;
	pid_t xmame_pid;
			
			
	command = g_strdup_printf("%s -verifyroms -stdout-file %s/.gxmame/verifyrom.tmp 2>/dev/null",real_mame_executable,getenv("HOME"));
	xmame_pid = fork();

	if ( xmame_pid > 0 )
	{
		/* this is the parent process*/
		time_t tm_start,
		       tm_now;
		FILE *xmame_output = NULL;
		time(&tm_start);
		time(&tm_now);

		while ( xmame_output == NULL &&
		        tm_now - tm_start < 5 )
		{
			xmame_output = fopen("/home/shad/.gxmame/verifyrom.tmp", "r");
			time(&tm_now);
		}
		if ( xmame_output )
		{
			char go_on = 1;

			while ( go_on )
			{
				/* let gtk process events while we parse...*/
				      while (gtk_events_pending()) gtk_main_iteration();

				if ( fgets(line, 200, xmame_output) )
				{	  
					line[strlen(line) - 1] = 0;
					if (!strncmp(line,"romset",6))
				  	{
						printf("xmame: %s\n",line);
				        	/*p = name = line+8;*/
				        	for(p = name = line+7;(*p && (*p != ' '));p++);
				        	*p='\0';p++;
				        	done = (gfloat) ((gfloat) (nb_checked) /
				        	        	(gfloat) (supported_games));
				        	if (!strncmp(p,"correct",7))
				        	{
				        	        nb_good++;
				        	        g_snprintf(numb,10,"%d",nb_good);
				        	        gtk_label_set_text(GTK_LABEL(correct_roms_value),numb);
				        	        g_snprintf(numb,10,"%d",nb_good+nb_incorrect);
				        	        gtk_label_set_text(GTK_LABEL(total_roms_value),numb);
				        	        status = 1;
				        	}
				        	else if (!strncmp(p,"incorrect",9) && error_during_check==TRUE)
				        	{
				        	        nb_incorrect++;
				        	        g_snprintf(numb,10,"%d",nb_incorrect);
				        	        gtk_label_set_text(GTK_LABEL(incorrect_roms_value),numb);
				        	        g_snprintf(numb,10,"%d",nb_good+nb_incorrect);
				        	        gtk_label_set_text(GTK_LABEL(total_roms_value),numb);
				        	        status = 0;
				        	} else if (!strncmp(p,"not found",9))
				        	        status = 0;
				        	else if (!strncmp(p,"best available",14))
				        	        status = 1;
				        	else 
				        	        status = 2;
				        	        
				        	        
				        	/* find the rom in the list */
				        	for(listpointer = g_list_first(roms), game_found = FALSE;
				        	        	(listpointer != NULL);
				        	        	listpointer = g_list_next(listpointer))
				        	{
				        	        tmprom = (RomEntry *) listpointer->data;
				        	        if (!strcmp(tmprom->romname,name))
				        	        {
				        	        	game_found = TRUE;
				        	        	break;
				        	        }
				        	}
				        	if (game_found)
				        	{
				        	        tmprom->has_roms = status;
				        	        g_snprintf(title,BUFFER_SIZE,_("Checking Game %s %s %s"),name, tmprom->gamename,tmprom->gamenameext );
				        	        if (tmprom->the_trailer && gui_prefs.ModifyThe)
				        	        	g_snprintf(title,BUFFER_SIZE,_("Checking Game %s, The %s"),tmprom->gamename,tmprom->gamenameext);
				        	        else if (tmprom->the_trailer && !gui_prefs.ModifyThe)
				        	        	g_snprintf(title,BUFFER_SIZE,_("Checking Game The %s %s"),tmprom->gamename,tmprom->gamenameext);
				        	        else
				        	        	g_snprintf(title,BUFFER_SIZE,_("Checking Game %s %s"),tmprom->gamename,tmprom->gamenameext);
				        	}
				        	else
				        	{/* haven't found the game, just diplay the gamename */
				        	        g_snprintf(title,BUFFER_SIZE,_("Checking Game %s"),name);
				        	}
				        	/*continue with the GUI */
				        	nb_checked++;
				        	error_during_check = FALSE;
				        	gtk_window_set_title (GTK_WINDOW (checking_games_window), title);
				        	gtk_progress_bar_update(GTK_PROGRESS_BAR(roms_check_progressbar),done);
				        	if (nb_checked>=supported_games)
				        	        go_on=0;
				        	while (gtk_events_pending()) gtk_main_iteration();
					}
				 	else
				 	{
				 		g_snprintf(title,BUFFER_SIZE,"%s\n",line);
				 		
				 		gtk_text_insert (GTK_TEXT (details_check_text), NULL, NULL, NULL,title, -1);
				 		error_during_check = TRUE;
				 		while (gtk_events_pending()) gtk_main_iteration();
				 	}
				}
			}

			if ( xmame_output )
			  fclose(xmame_output);

			g_message("done");
		}
		else
		{
		  g_message("WARNING: missing output from external process");
		}


		wait(NULL);
	}
	else if ( xmame_pid < 0 )
	{
	  	/* fork() failed*/
	  	g_message("WARNING: fork() system call failed; errno = %d", errno);
	}
	else
	{
	  	/* this is the client process*/
		gxmame_debug("running command %s",command);
		system(command);
		_exit(0);
	}

	g_free(command);
}


void launch_checking_games_window_3(void)
{
	FILE *xmame_pipe=NULL;
	gchar line[BUFFER_SIZE];
	gchar title[BUFFER_SIZE];
	gchar numb[10];
	gfloat done;
	guint nb_checked = 1,nb_good = 0,nb_incorrect = 0;
	gboolean error_during_check=FALSE,game_found;
	gchar *command, *p, *name;
	GList *listpointer;
	RomEntry *tmprom = NULL;
	guint status;
	pid_t xmame_pid;
	int filedes[2];
			
			
	command = g_strdup_printf("%s -verifyroms 2>/dev/null",real_mame_executable);
	if (!pipe(filedes))
		printf("pipe created\n");
	xmame_pid = fork();

	if ( xmame_pid > 0 )
	{	
		/* this is the parent process*/
		time_t tm_start,
		       tm_now;
		FILE *xmame_output = NULL;
		time(&tm_start);
		time(&tm_now);

		close(filedes[1]);
		while ( tm_now - tm_start < 5 )
		{
			time(&tm_now);
		}
		if ( 1)
		{
			char go_on = 1;

			while ( go_on )
			{
				/* let gtk process events while we parse...*/
				      while (gtk_events_pending()) gtk_main_iteration();

				if ( read(filedes[0], line, BUFFER_SIZE) )
				{	  
					printf("received:{%s}\n",line);
					line[strlen(line) - 1] = 0;
					if (!strncmp(line,"romset",6))
				  	{
						printf("xmame: %s\n",line);
				        	/*p = name = line+8;*/
				        	for(p = name = line+7;(*p && (*p != ' '));p++);
				        	*p='\0';p++;
				        	done = (gfloat) ((gfloat) (nb_checked) /
				        	        	(gfloat) (supported_games));
				        	if (!strncmp(p,"correct",7))
				        	{
				        	        nb_good++;
				        	        g_snprintf(numb,10,"%d",nb_good);
				        	        gtk_label_set_text(GTK_LABEL(correct_roms_value),numb);
				        	        g_snprintf(numb,10,"%d",nb_good+nb_incorrect);
				        	        gtk_label_set_text(GTK_LABEL(total_roms_value),numb);
				        	        status = 1;
				        	}
				        	else if (!strncmp(p,"incorrect",9) && error_during_check==TRUE)
				        	{
				        	        nb_incorrect++;
				        	        g_snprintf(numb,10,"%d",nb_incorrect);
				        	        gtk_label_set_text(GTK_LABEL(incorrect_roms_value),numb);
				        	        g_snprintf(numb,10,"%d",nb_good+nb_incorrect);
				        	        gtk_label_set_text(GTK_LABEL(total_roms_value),numb);
				        	        status = 0;
				        	} else if (!strncmp(p,"not found",9))
				        	        status = 0;
				        	else if (!strncmp(p,"best available",14))
				        	        status = 1;
				        	else 
				        	        status = 2;
				        	        
				        	        
				        	/* find the rom in the list */
				        	for(listpointer = g_list_first(roms), game_found = FALSE;
				        	        	(listpointer != NULL);
				        	        	listpointer = g_list_next(listpointer))
				        	{
				        	        tmprom = (RomEntry *) listpointer->data;
				        	        if (!strcmp(tmprom->romname,name))
				        	        {
				        	        	game_found = TRUE;
				        	        	break;
				        	        }
				        	}
				        	if (game_found)
				        	{
				        	        tmprom->has_roms = status;
				        	        g_snprintf(title,BUFFER_SIZE,_("Checking Game %s %s %s"),name, tmprom->gamename,tmprom->gamenameext );
				        	        if (tmprom->the_trailer && gui_prefs.ModifyThe)
				        	        	g_snprintf(title,BUFFER_SIZE,"Checking Game %s, The %s",tmprom->gamename,tmprom->gamenameext);
				        	        else if (tmprom->the_trailer && !gui_prefs.ModifyThe)
				        	        	g_snprintf(title,BUFFER_SIZE,"Checking Game The %s %s",tmprom->gamename,tmprom->gamenameext);
				        	        else
				        	        	g_snprintf(title,BUFFER_SIZE,"Checking Game %s %s",tmprom->gamename,tmprom->gamenameext);
				        	}
				        	else
				        	{/* haven't found the game, just diplay the gamename */
				        	        g_snprintf(title,BUFFER_SIZE,_("Checking Game %s"),name);
				        	}
				        	/*continue with the GUI */
				        	nb_checked++;
				        	error_during_check = FALSE;
				        	gtk_window_set_title (GTK_WINDOW (checking_games_window), title);
				        	gtk_progress_bar_update(GTK_PROGRESS_BAR(roms_check_progressbar),done);
				        	if (nb_checked>=supported_games)
				        	        go_on=0;
				        	while (gtk_events_pending()) gtk_main_iteration();
					}
				 	else
				 	{
				 		g_snprintf(title,BUFFER_SIZE,"%s\n",line);
				 		
				 		gtk_text_insert (GTK_TEXT (details_check_text), NULL, NULL, NULL,title, -1);
				 		error_during_check = TRUE;
				 		while (gtk_events_pending()) gtk_main_iteration();
				 	}
				}
			}

			if ( xmame_output )
			  fclose(xmame_output);

			g_message("done");
		}
		else
		{
		  g_message("WARNING: missing output from external process");
		}


		wait(NULL);
	}
	else if ( xmame_pid < 0 )
	{
	  	/* fork() failed*/
	  	g_message("WARNING: fork() system call failed; errno = %d", errno);
	}
	else
	{
	  	/* this is the client process */
		close(filedes[0]);
		gxmame_debug("running command %s",command);
		xmame_pipe = popen(command, "r");
		while (fgets(line, BUFFER_SIZE, xmame_pipe))
		{
			printf("sending %s",line);
			write(filedes[1], line , BUFFER_SIZE);
		}
		pclose(xmame_pipe);
		_exit(0);
	}

	g_free(command);
}


