/*
 * GXMame
 *
 * 2002, 2003, Stphane Pontier <shadow_walker@users.sourceforge.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Original code taken from:
 * gtkjoy.c
 *
 * general routines for handling joystick events
 *
 * Copyright 1999 David Boynton.
 * http://trylinux.com/projects/joystick/
 */
#ifndef __gtkjoy_h
#define __gtkjoy_h

#include <gtk/gtk.h>

#define AXIS_MAX	32767
#define AXIS_MIN	-32768

#define JOYSTICK_MAXA	16
#define JOYSTICK_MAXB	16

typedef void (*joystick_callback)(gint, gint, gpointer); 
	
typedef struct _JoyData {
	int joystickfd;
	int version;
	int num_axis;
	int num_buttons;
	char * device_name;
	joystick_callback callback;
	gpointer callback_data;
	gint gdktag;
	int axis[JOYSTICK_MAXA]; 
	int buttons[JOYSTICK_MAXB]; 
} JoyData;

JoyData * joystick_new(char * joystick, void * owner, void * data);
void joystick_close(JoyData *joydata);
void joy_focus_on(void);
void joy_focus_off(void);

void 
joystick_events(gint eventtype, gint button, gpointer data);

#endif
